#!/usr/bin/env python
import setpath
import unittest
import os
from bike.testutils import trimLines
from common import indexToCoordinates

class TestIndexToCoordinates(unittest.TestCase):
    def test_worksOnSingleLineString(self):
        src = trimLines('''
        foo bah 
        ''')
        x,y = indexToCoordinates(src,src.index("bah"))
        self.assertEqual(x,4)
        self.assertEqual(y,0)
        x,y = indexToCoordinates(src,src.index("foo"))
        self.assertEqual(x,0)
        self.assertEqual(y,0)

    def test_worksOnMultilLineString(self):
        src = trimLines('''
        foo bah 
        baz boh
        ''')
        x,y = indexToCoordinates(src,src.index("boh"))
        self.assertEqual(x,4)
        self.assertEqual(y,1)

        
if __name__ == "__main__":
    unittest.main()
