import compiler
from bike.parsing.utils import fqn_rcdr, fqn_rcar
from bike.query.getReferencesToClass import getReferencesToClass
from bike.query.getTypeOf import getTypeOf
from bike.transformer.WordRewriter import WordRewriter
import re


classNameRE = re.compile("^\s*class (\w+)")

def renameClass(ast, fqn, newname, **opts):
    strrewrite = WordRewriter()
    #print "fqn is ",fqn
    cl = getTypeOf(ast,fqn)
    lineno = cl.getStartLine()
    line = cl.module.getSourceNode().getLines()[lineno-1]
    match = classNameRE.match(line)
    # do the rename
    strrewrite.rewriteString(cl.module.getSourceNode(), lineno,
                             match.start(1), newname)

    # rename the references
    classname = cl.name
    for ref in getReferencesToClass(ast, fqn):
        mod = getTypeOf(ast,ref.modulefqn)
        srcnode = mod.getSourceNode()
        strrewrite.rewriteString(srcnode, ref.lineno, ref.colno, newname)
    strrewrite.commit()


