from bike.refactor.renameClass import WordRewriter
from bike.query.getReferencesToClass import getReferencesToClass
from bike.query.getTypeOf import getTypeOf
import re


fnNameRE = re.compile("^\s*def (\w+)")

def renameFunction(ast, fqn, newname, **opts):
    strrewrite = WordRewriter()
    fn = getTypeOf(ast,fqn)
    lineno = fn.getStartLine()
    line = fn.module.getSourceNode().getLines()[lineno-1]
    match = fnNameRE.match(line)
    # do the rename
    strrewrite.rewriteString(fn.module.getSourceNode(), lineno,
                             match.start(1), newname)

    # rename the references
    for ref in getReferencesToClass(ast, fqn):
        mod = getTypeOf(ast,ref.modulefqn)
        srcnode = mod.getSourceNode()
        strrewrite.rewriteString(srcnode, ref.lineno, ref.colno, newname)
    strrewrite.commit()

