from bike.parsing.extended_ast import Root, Source, Package, Name, Class
#from bike.parsing.utils import fqn_rcar, fqn_rcdr
#import compiler

import compiler
from bike.parsing.utils import fqn_rcdr, fqn_rcar
from bike.query.getReferencesToMethod import getReferencesToMethod
from bike.query.getTypeOf import getTypeOf
from bike.transformer.WordRewriter import WordRewriter
import re
from bike.query.relationships import getChildByName,getAllClassesInHierarchy
from bike.parsing.fastparserast import Function

fnNameRE = re.compile("^\s*def (\w+)")

def renameMethod(root, fqn, newname, **opts):
    strrewrite = WordRewriter()

    classfqn = fqn.split(".")[:-1]
    methodname = fqn.split(".")[-1]

    classobj = getTypeOf(root,".".join(classfqn))
    for classobj in getAllClassesInHierarchy(root,classobj):
        fn = getChildByName(classobj,methodname)
        if fn and isinstance(fn,Function):
            lineno = fn.getStartLine()
            line = fn.module.getSourceNode().getLines()[lineno-1]
            match = fnNameRE.match(line)
            # do the rename
            strrewrite.rewriteString(fn.module.getSourceNode(), lineno,
                                     match.start(1), newname)            

    # rename the references
    for ref in getReferencesToMethod(root, fqn):

        if ref.confidence == 100 or promptUser(opts,ref) == 1:
            mod = getTypeOf(root,ref.modulefqn)
            srcnode = mod.getSourceNode()
            strrewrite.rewriteString(srcnode, ref.lineno, ref.colno, newname)
            
    strrewrite.commit()


def promptUser(opts,ref):
    if opts.has_key('promptCallback') and opts['promptCallback'] is not None:
        if opts['promptCallback'](ref.filename, ref.lineno, ref.colno, ref.colend):
            return 1
    return 0
    
