#!/usr/bin/env python
import setpath
import unittest
from testutils import*
import testdata
import sys
from bike.parsing.extended_ast import Root


class TestCreateSourceFileAt(unittest.TestCase):
    def test_putsTheSourceFileInPackage(self):
        top = Root([], [], [])
        createSourceNodeAt(top, "pass", "a.b.c.foo");
        assert top.getPackage("a").getPackage("b").getPackage("c").getSource("foo")

    def test_canPutASourceFileInAnAlreadyExistingPackage(self):
        top = Root([], [], [])
        createSourceNodeAt(top, "pass", "a.foo");
        createSourceNodeAt(top, "pass", "a.bah");
        assert top.getPackage("a").getSource("foo")
        assert top.getPackage("a").getSource("bah")

if __name__ == "__main__":
    unittest.main()
